#! /usr/bin/env python3.4

def get_sleds_score(gems, pos_i, pos_j):
    score = 0
    n = 1
    for i in range(pos_i+1, 8):
        if gems[i][pos_j] == gems[pos_i][pos_j]:
            n += 1
        else:
            break
    for i in range(pos_i-1, -1, -1):
        if gems[i][pos_j] == gems[pos_i][pos_j]:
            n += 1
        else:
            break
    if n > 2:
        score = (n - 2) * 3
    n = 1
    for j in range(pos_j+1, 8):
        if gems[pos_i][j] == gems[pos_i][pos_j]:
            n += 1
        else:
            break
    for j in range(pos_j-1, -1, -1):
        if gems[pos_i][j] == gems[pos_i][pos_j]:
            n += 1
        else:
            break
    if n > 2:
        return score + ((n - 2) * 3)
    else:
        return score

def write_to_file(i, j, k, l):
    with open('vystup.txt', 'w') as f:
        f.write("{} {} {} {}".format(j+1, i+1, l+1, k+1))

with open('vstup.txt', 'r') as f:
    lines = f.read().splitlines()

steps = int(lines[0])
gems = []
for line in lines[1:]:
    gems.append([int(char_) for char_ in line])

max_score = 0
max_score_pos = (0,0,0,0)

for i in range(8):
    for j in range(8):
        if i+1 < 8:
            gems[i][j], gems[i+1][j] = gems[i+1][j], gems[i][j]
            score = get_sleds_score(gems, i, j) + get_sleds_score(gems, i+1, j)
            if score > max_score:
                max_score = score
                max_score_pos = (i, j, i+1, j)
            gems[i][j], gems[i+1][j] = gems[i+1][j], gems[i][j]
        if j+1 < 8:
            gems[i][j], gems[i][j+1] = gems[i][j+1], gems[i][j]
            score = get_sleds_score(gems, i, j) + get_sleds_score(gems, i, j+1)
            if score > max_score:
                max_score = score
                max_score_pos = (i, j, i, j+1)
            gems[i][j], gems[i][j+1] = gems[i][j+1], gems[i][j]

write_to_file(*max_score_pos)
